import java.util.*;
 
import javax.persistence.*;
 
 
public class Test {
 
    public static void main(String [] args){
 
        EntityManagerFactory emf =
            Persistence.createEntityManagerFactory(
                "objectdb:test.tmp;drop");
        EntityManager em = emf.createEntityManager();
 
        em.getTransaction().begin();
        B b = new B();
        em.persist(b);
        A a1 = new A();
        a1.add(b);
        em.persist(a1);
        A a2 = new A();
        em.persist(a2);
        em.getTransaction().commit();
 
        Query query = em.createQuery(
//            "SELECT a,b FROM A a INNER JOIN a.list b");
            "SELECT a,b FROM A a LEFT OUTER JOIN a.list b");

        List resultList = query.getResultList();
        for (Iterator it=resultList.iterator(); it.hasNext(); ) {
            Object obj = it.next();
            if (obj instanceof Object[]) 
                System.out.println( Arrays.toString((Object[])obj) );
            else 
                System.out.println( obj.toString() );
        } 
  
        em.close();
        emf.close();
    }
 
    @Entity
    static class A {
        @Id @GeneratedValue long id;
 
        @OneToMany(mappedBy="a")
        ArrayList<B> list = new ArrayList<B>();
 
        void add(B b) {
            list.add(b);
            b.a = this;
        } 
 
        @Override
        public String toString() {
            return "A" + id;
        }
    }
 
    @Entity
    static class B {
        @Id @GeneratedValue long id;
 
        @ManyToOne
        A a;       

        @Override
        public String toString() {
            return "B" + id;
        }
    }
}
